package TehFail
{
function armor::onDisabled(%datablock, %object)
{
	if(%object.getClassName() $= "AIPlayer")
	{
		if(%object.isBeingControlled == 1)
		{
			if(!%object.spawnBrick)
			{
				%client = %object.client;
				%this = %object.spawnBrick;
				if(!%client.mainP)
				{
					messageClient(%client,'',"Error: \c6Not in control of a bot.");
					Parent::onDisabled(%datablock, %object);
				}
				else
				{
					%clientz = %this.controller;
					%clientz.player = %clientz.mainP;
					%clientz.setControlObject(%clientz.mainP);
					%clientz.mainP = 0;
					%this.vehicle.isBeingControlled = 0;
					%this.onVehicleExitControl(%clientz);
					%this.vehicle.client = findClientByBL_ID(getBrickGroupFromObject(%this).bl_id);
					%this.controller = 0;
					Parent::onDisabled(%datablock, %object);
				}
			}
			else
			{
				%clientz = %object.client;
				%clientz.player = %clientz.mainP;
				%clientz.setControlObject(%clientz.mainP);
				%clientz.mainP = 0;
				messageClient(%client,'',"Error: \c6The bot spawn got deleted while you were controlling it.");
				Parent::onDisabled(%datablock, %object);
			}
		}
		else
		{
			Parent::onDisabled(%datablock, %object);
		}
	}
	else
	{
		Parent::onDisabled(%datablock, %object);
	}
}
};

activatePackage(TehFail);		

function fxDTSBrick::setVehicleAsPlayerControl(%this,%client)
{
	if(!%this.vehicle.isBeingControlled)
	{
		if(!%this.vehicle)
		{
			messageClient(%client,'',"Error: \c6Cannot become unexisting bot.");
		}
		else
		{
			%client.mainP = %client.player;
			%client.player = %this.vehicle;
			%client.setControlObject(%this.vehicle);
			%this.onVehicleStartControl(%client);
			%this.vehicle.isBeingControlled = 1;
			%this.vehicle.client = %client;
			%this.controller = %client;
		}
	}
	else
	{
		messageClient(%client,'',"Error: \c6This bot is already being controlled.");
	}
}

function fxDTSBrick::exitVehicleControl(%this,%client)
{
	if(!%client.mainP)
	{
		messageClient(%client,'',"Error: \c6Not in control of a bot.");
	}
	else
	{
		%clientz = %this.controller;
		%clientz.player = %clientz.mainP;
		%clientz.setControlObject(%clientz.mainP);
		%clientz.mainP = 0;
		%this.vehicle.isBeingControlled = 0;
		%this.onVehicleExitControl(%clientz);
		%this.vehicle.client = findClientByBL_ID(getBrickGroupFromObject(%this).bl_id);
		%this.controller = 0;
	}
}

function fxDTSBrick::onVehicleStartControl(%this,%client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_minigame = getMinigameFromObject(%this);
	$inputTarget_vehicle = %this.vehicle;
	%this.processInputEvent("onVehicleStartControl",%client);
}

function fxDTSBrick::onVehicleExitControl(%this,%client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_minigame = getMinigameFromObject(%this);
	$inputTarget_vehicle = %this.vehicle;
	%this.processInputEvent("onVehicleExitControl",%client);
}

registerOutputEvent(fxDTSBrick,"setVehicleAsPlayerControl","",1);
registerOutputEvent(fxDTSBrick,"exitVehicleControl","",1);
registerInputEvent(fxDTSBrick,"onVehicleStartControl","Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame\tVehicle Vehicle",1);
registerInputEvent(fxDTSBrick,"onVehicleExitControl","Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame\tVehicle Vehicle",1);